//+------------------------------------------------------------------+
//|                                             $HitryDispersion.mq4 |
//|                                                             Alex |
//|                                                   al53@yandex.ru |
//+------------------------------------------------------------------+
//           ,      
//              .
#property copyright "Alex"
#property link      "al53@yandex.ru"
#property indicator_chart_window
#property indicator_buffers 3
#property indicator_color1 Red
#property indicator_color2 Blue
#property indicator_color3 Green
//---- input parameters
extern int       Sredn=30;
extern double       Disp=2; //       
extern int       Rashet=5000 ; //   -     
//---- buffers
double Ind[];   //       Sredn
double IndDisp[] ;  //                
double StopLoss[] ;  //             
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   SetIndexStyle(0,DRAW_LINE);
   SetIndexBuffer(0,Ind);
   SetIndexStyle(1,DRAW_LINE);
   SetIndexBuffer(1,IndDisp);
   SetIndexStyle(2,DRAW_LINE);
   SetIndexBuffer(2,StopLoss);
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int    counted_bars=IndicatorCounted();
double  abc,bcd ;
   int limit;
    if(counted_bars > 0) counted_bars--;
     limit=Bars-counted_bars-Sredn;
    if (limit < Sredn)
       limit =Sredn+2 ;
    if (limit > 5000)   limit=5000 ;
       for (int i=0; i<=limit ;i++)
       {
         for (int j=0; j <= Sredn  ; j++)
            {
               abc=Open[i+j]-iMA(Symbol(),0,Sredn,0,MODE_SMMA,PRICE_OPEN,i+j) ;
               bcd=bcd+abc*MathAbs(abc) ;   //        
            }
           abc=(bcd/MathAbs(bcd))*MathSqrt(MathAbs(bcd/Sredn)) ; //         
           Ind[i]=iMA(Symbol(),0,Sredn,0,MODE_SMMA,PRICE_OPEN,i) ;
           IndDisp[i]=iMA(Symbol(),0,Sredn,0,MODE_SMMA,PRICE_OPEN,i)+abc*Disp  ; //      
           //StopLoss[i]=iMA(Symbol(),0,Sredn,0,MODE_SMA,PRICE_OPEN,i)-abc*Disp  ;
           abc=0 ;
           bcd=0 ;
           
       }
   return(0);
  }
//+------------------------------------------------------------------+